package ssa

import (
	"strconv"

	"git.urbach.dev/cli/q/src/types"
)

type Int struct {
	Int int
	Liveness
	Source
}

func (v *Int) Inputs() []Value  { return nil }
func (v *Int) IsConst() bool    { return true }
func (v *Int) String() string   { return strconv.Itoa(v.Int) }
func (v *Int) Type() types.Type { return types.AnyInt }

func (a *Int) Equals(v Value) bool {
	b, sameType := v.(*Int)

	if !sameType {
		return false
	}

	return a.Int == b.Int
}